// Code generated by protoc-gen-micro. DO NOT EDIT.
// source: proto/comments.proto

package comments

import (
	fmt "fmt"
	proto "github.com/golang/protobuf/proto"
	math "math"
)

import (
	context "context"
	api "github.com/micro/micro/v3/service/api"
	client "github.com/micro/micro/v3/service/client"
	server "github.com/micro/micro/v3/service/server"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.ProtoPackageIsVersion3 // please upgrade the proto package

// Reference imports to suppress errors if they are not otherwise used.
var _ api.Endpoint
var _ context.Context
var _ client.Option
var _ server.Option

// Api Endpoints for Comments service

func NewCommentsEndpoints() []*api.Endpoint {
	return []*api.Endpoint{}
}

// Client API for Comments service

type CommentsService interface {
	List(ctx context.Context, in *ListRequest, opts ...client.CallOption) (*ListResponse, error)
	Create(ctx context.Context, in *CreateRequest, opts ...client.CallOption) (*CreateResponse, error)
	Read(ctx context.Context, in *ReadRequest, opts ...client.CallOption) (*ReadResponse, error)
	Delete(ctx context.Context, in *DeleteRequest, opts ...client.CallOption) (*DeleteResponse, error)
	Update(ctx context.Context, in *UpdateRequest, opts ...client.CallOption) (*UpdateResponse, error)
	Events(ctx context.Context, in *EventsRequest, opts ...client.CallOption) (Comments_EventsService, error)
}

type commentsService struct {
	c    client.Client
	name string
}

func NewCommentsService(name string, c client.Client) CommentsService {
	return &commentsService{
		c:    c,
		name: name,
	}
}

func (c *commentsService) List(ctx context.Context, in *ListRequest, opts ...client.CallOption) (*ListResponse, error) {
	req := c.c.NewRequest(c.name, "Comments.List", in)
	out := new(ListResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *commentsService) Create(ctx context.Context, in *CreateRequest, opts ...client.CallOption) (*CreateResponse, error) {
	req := c.c.NewRequest(c.name, "Comments.Create", in)
	out := new(CreateResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *commentsService) Read(ctx context.Context, in *ReadRequest, opts ...client.CallOption) (*ReadResponse, error) {
	req := c.c.NewRequest(c.name, "Comments.Read", in)
	out := new(ReadResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *commentsService) Delete(ctx context.Context, in *DeleteRequest, opts ...client.CallOption) (*DeleteResponse, error) {
	req := c.c.NewRequest(c.name, "Comments.Delete", in)
	out := new(DeleteResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *commentsService) Update(ctx context.Context, in *UpdateRequest, opts ...client.CallOption) (*UpdateResponse, error) {
	req := c.c.NewRequest(c.name, "Comments.Update", in)
	out := new(UpdateResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *commentsService) Events(ctx context.Context, in *EventsRequest, opts ...client.CallOption) (Comments_EventsService, error) {
	req := c.c.NewRequest(c.name, "Comments.Events", &EventsRequest{})
	stream, err := c.c.Stream(ctx, req, opts...)
	if err != nil {
		return nil, err
	}
	if err := stream.Send(in); err != nil {
		return nil, err
	}
	return &commentsServiceEvents{stream}, nil
}

type Comments_EventsService interface {
	Context() context.Context
	SendMsg(interface{}) error
	RecvMsg(interface{}) error
	Close() error
	Recv() (*EventsResponse, error)
}

type commentsServiceEvents struct {
	stream client.Stream
}

func (x *commentsServiceEvents) Close() error {
	return x.stream.Close()
}

func (x *commentsServiceEvents) Context() context.Context {
	return x.stream.Context()
}

func (x *commentsServiceEvents) SendMsg(m interface{}) error {
	return x.stream.Send(m)
}

func (x *commentsServiceEvents) RecvMsg(m interface{}) error {
	return x.stream.Recv(m)
}

func (x *commentsServiceEvents) Recv() (*EventsResponse, error) {
	m := new(EventsResponse)
	err := x.stream.Recv(m)
	if err != nil {
		return nil, err
	}
	return m, nil
}

// Server API for Comments service

type CommentsHandler interface {
	List(context.Context, *ListRequest, *ListResponse) error
	Create(context.Context, *CreateRequest, *CreateResponse) error
	Read(context.Context, *ReadRequest, *ReadResponse) error
	Delete(context.Context, *DeleteRequest, *DeleteResponse) error
	Update(context.Context, *UpdateRequest, *UpdateResponse) error
	Events(context.Context, *EventsRequest, Comments_EventsStream) error
}

func RegisterCommentsHandler(s server.Server, hdlr CommentsHandler, opts ...server.HandlerOption) error {
	type comments interface {
		List(ctx context.Context, in *ListRequest, out *ListResponse) error
		Create(ctx context.Context, in *CreateRequest, out *CreateResponse) error
		Read(ctx context.Context, in *ReadRequest, out *ReadResponse) error
		Delete(ctx context.Context, in *DeleteRequest, out *DeleteResponse) error
		Update(ctx context.Context, in *UpdateRequest, out *UpdateResponse) error
		Events(ctx context.Context, stream server.Stream) error
	}
	type Comments struct {
		comments
	}
	h := &commentsHandler{hdlr}
	return s.Handle(s.NewHandler(&Comments{h}, opts...))
}

type commentsHandler struct {
	CommentsHandler
}

func (h *commentsHandler) List(ctx context.Context, in *ListRequest, out *ListResponse) error {
	return h.CommentsHandler.List(ctx, in, out)
}

func (h *commentsHandler) Create(ctx context.Context, in *CreateRequest, out *CreateResponse) error {
	return h.CommentsHandler.Create(ctx, in, out)
}

func (h *commentsHandler) Read(ctx context.Context, in *ReadRequest, out *ReadResponse) error {
	return h.CommentsHandler.Read(ctx, in, out)
}

func (h *commentsHandler) Delete(ctx context.Context, in *DeleteRequest, out *DeleteResponse) error {
	return h.CommentsHandler.Delete(ctx, in, out)
}

func (h *commentsHandler) Update(ctx context.Context, in *UpdateRequest, out *UpdateResponse) error {
	return h.CommentsHandler.Update(ctx, in, out)
}

func (h *commentsHandler) Events(ctx context.Context, stream server.Stream) error {
	m := new(EventsRequest)
	if err := stream.Recv(m); err != nil {
		return err
	}
	return h.CommentsHandler.Events(ctx, m, &commentsEventsStream{stream})
}

type Comments_EventsStream interface {
	Context() context.Context
	SendMsg(interface{}) error
	RecvMsg(interface{}) error
	Close() error
	Send(*EventsResponse) error
}

type commentsEventsStream struct {
	stream server.Stream
}

func (x *commentsEventsStream) Close() error {
	return x.stream.Close()
}

func (x *commentsEventsStream) Context() context.Context {
	return x.stream.Context()
}

func (x *commentsEventsStream) SendMsg(m interface{}) error {
	return x.stream.Send(m)
}

func (x *commentsEventsStream) RecvMsg(m interface{}) error {
	return x.stream.Recv(m)
}

func (x *commentsEventsStream) Send(m *EventsResponse) error {
	return x.stream.Send(m)
}
